Bugs in socket.rb (exception retrieval)

12/13/2013 11:58 PM - ko1 (Koichi Sasada)

Status: Closed   

Priority: Normal   

Assignee: usa (Usaku NAKAMURA)   

Target version:    

ruby -v: ruby 2.1.0dev (2013-12-13 trunk 44170)

[i386-mswin32_110]

Backport: 1.9.3: DONE, 2.0.0: DONE

Description

Ruby 2.1 (trunk) 2.0 and 1.9.3 both has a bug to retrieve exception.

In the following code, opened socket is always closed.

require 'socket'

ai = Addrinfo.tcp(nil, 12345)

begin

raise

rescue

p ai.listen #=> #Socket:(closed)

end

This is because in socket.rb, there are such error handling code:

creates a listening socket bound to self.

def listen(backlog=Socket::SOMAXCONN)

sock = Socket.new(self.pfamily, self.socktype, self.protocol)

begin

sock.ipv6only! if self.ipv6?

sock.setsockopt(:SOCKET, :REUSEADDR, 1)

sock.bind(self)

sock.listen(backlog)

if block_given?

yield sock

else

sock

end

ensure

### THIS LINE CLOSE `sock' every time when $! is not nil

sock.close if !sock.closed? && (block_given? || $!)

end

end

There are similar code in socket.rb.

akr-san already knows this issue.

This ticket is to note issues.

We realize this issue because webrick use this feature from 2.1.

The following code no longer works on 2.1.

begin

require 'xyzzy' # something like webrick

rescue LoadError

require 'webrick'

server = WEBrick::HTTPServer.new(Port: 12345)

end

Because $! is an instance of LoadError.
Associated revisions

Revision 4fd53e476e493630a140edc085c71f2670d74942 - 12/13/2013 04:11 PM - akr (Akira Tanaka)

ext/socket/lib/socket.rb: Don't test $! in "ensure" clause because

it may be set before the body.

Reported by ko1 and mrkn.  [ruby-core:59088] [Bug #9247]

lib/cgi/core.rb: Ditto.

lib/drb/ssl.rb: Ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@44184 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 4fd53e47 - 12/13/2013 04:11 PM - akr (Akira Tanaka)

ext/socket/lib/socket.rb: Don't test $! in "ensure" clause because

it may be set before the body.

Reported by ko1 and mrkn.  [ruby-core:59088] [Bug #9247]

lib/cgi/core.rb: Ditto.

lib/drb/ssl.rb: Ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@44184 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ad5757276d48761ff9e071991d3957f75ce2d4b4 - 12/24/2013 03:37 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 44184: [Backport #9247]

    * ext/socket/lib/socket.rb: Don't test $! in "ensure" clause because

      it may be set before the body.

      Reported by ko1 and mrkn.  [ruby-core:59088] [Bug #9247]

    * lib/cgi/core.rb: Ditto.

    * lib/drb/ssl.rb: Ditto.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@44390 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ad575727 - 12/24/2013 03:37 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 44184: [Backport #9247]

    * ext/socket/lib/socket.rb: Don't test $! in "ensure" clause because

      it may be set before the body.

      Reported by ko1 and mrkn.  [ruby-core:59088] [Bug #9247]

    * lib/cgi/core.rb: Ditto.

    * lib/drb/ssl.rb: Ditto.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@44390 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 75c84da28c5e9169a4d48efd1a542d8278b1d436 - 01/30/2014 12:04 PM - U.Nakamura 

merge revision(s) 44184: [Backport #9247]

    * ext/socket/lib/socket.rb: Don't test $! in "ensure" clause because

      it may be set before the body.

      Reported by ko1 and mrkn.  [ruby-core:59088] [Bug #9247]

    * lib/cgi/core.rb: Ditto.

    * lib/drb/ssl.rb: Ditto.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_3@44767 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 75c84da2 - 01/30/2014 12:04 PM - U.Nakamura 

merge revision(s) 44184: [Backport #9247]

    * ext/socket/lib/socket.rb: Don't test $! in "ensure" clause because

      it may be set before the body.

      Reported by ko1 and mrkn.  [ruby-core:59088] [Bug #9247]

    * lib/cgi/core.rb: Ditto.

    * lib/drb/ssl.rb: Ditto.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_3@44767 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 12/14/2013 12:19 AM - mrkn (Kenta Murata)

- Description updated

I think the following code can reproduce the full cases:

https://gist.github.com/mrkn/7945798

require 'socket'

Addrinfo#connect_internal

puts "(1) Addrinfo#connect (connect_internal)"

begin

raise

rescue

p Addrinfo.tcp('www.ruby-lang.org', 80).connect

end

Addrinfo.bind

puts "\n(2) Addrinfo#bind"

begin

ai = Addrinfo.tcp(nil, 11229)

raise

rescue

begin

p ai.bind

end

end

Addrinfo.listen

puts "\n(3) Addrinfo#listen"

begin

ai = Addrinfo.tcp(nil, 11228)

raise

rescue

begin

p ai.listen

end

end

Socket.ip_sockets_port0

puts "\n(4) Socket.tcp_server_sockets (ip_sockets_port0)"

begin

raise

rescue

begin

Socket.tcp_server_sockets(0)

rescue IOError

$stderr.puts "#{$!.class}: #{$!}", $!.backtrace

end

end
#2 - 12/14/2013 12:19 AM - mrkn (Kenta Murata)

- Status changed from Open to Assigned

#3 - 12/14/2013 01:11 AM - akr (Akira Tanaka)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r44184.

Koichi, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

ext/socket/lib/socket.rb: Don't test $! in "ensure" clause because

it may be set before the body.

Reported by ko1 and mrkn.  [ruby-core:59088] [Bug #9247]

lib/cgi/core.rb: Ditto.

lib/drb/ssl.rb: Ditto.

#4 - 12/24/2013 11:14 AM - ko1 (Koichi Sasada)

- Backport changed from 1.9.3: UNKNOWN, 2.0.0: UNKNOWN to 1.9.3: REQUIRED, 2.0.0: REQUIRED

#5 - 12/24/2013 11:15 AM - ko1 (Koichi Sasada)

- Status changed from Closed to Assigned

- Assignee changed from akr (Akira Tanaka) to nagachika (Tomoyuki Chikanaga)

#6 - 12/25/2013 12:38 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 1.9.3: REQUIRED, 2.0.0: REQUIRED to 1.9.3: REQUIRED, 2.0.0: DONE

r44184 was backported to ruby_2_0_0 at r44390.

#7 - 12/25/2013 12:38 AM - nagachika (Tomoyuki Chikanaga)

- Assignee changed from nagachika (Tomoyuki Chikanaga) to usa (Usaku NAKAMURA)

#8 - 01/30/2014 06:17 AM - hsbt (Hiroshi SHIBATA)

- Target version changed from 2.1.0 to 2.2.0

#9 - 01/30/2014 12:08 PM - usa (Usaku NAKAMURA)

- Status changed from Assigned to Closed

- Target version deleted (2.2.0)

- Backport changed from 1.9.3: REQUIRED, 2.0.0: DONE to 1.9.3: DONE, 2.0.0: DONE

backported into ruby_1_9_3 at r44767.

BTW, this problem was fixed before releacing ruby 2.1, so all active branches are now OK.
